//+------------------------------------------------------------------+
//|                                                   HighLowBar.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

extern string Begin     = "14:00";       //   
extern string End       = "23:00";       //   
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   for(int i=0;i<100;i++)
     {
      datetime dt=iTime(NULL,PERIOD_D1,i+1);
      
      datetime t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+Begin);
      datetime t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+End);

      int b1=iBarShift(NULL,0, t1);
      int b2=iBarShift(NULL,0, t2);
      

      
      
      
      
      
      
      int High_index=iHighest(NULL,0,MODE_HIGH,b1-b2,b2);
      int Low_index=iLowest(NULL,0,MODE_LOW,b1-b2,b2);

      double high = iHigh(NULL,0,High_index);
      double low  = iLow(NULL,0,Low_index);

      datetime time_High= iTime(NULL,0,High_index);
      datetime time_Low = iTime(NULL,0,Low_index);
      
     datetime time = iTime(NULL,PERIOD_D1,i)+24*60*60;
      
      SetTLine(clrWhite,"high  "+TimeToStr(time_High,TIME_DATE|TIME_MINUTES),time_High,high,time,high);
      SetTLine(clrWhite,"low  "+TimeToStr(time_Low,TIME_DATE|TIME_MINUTES)+".."+Low_index,time_Low,low,time,low);
   
   CreateRECTANGLE(clrMidnightBlue,"USA "+TimeToStr(iTime(NULL,0,b1),TIME_DATE|TIME_MINUTES),
              iTime(NULL,0,b1),high,iTime(NULL,0,b2),low);
   
   
     }

  }
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                        |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//-----------------------------------------------------------------------------
void CreateRECTANGLE(color cl,string no,
              datetime t1=0, double p1=0, datetime t2=0, double p2=0, int st=0,bool Back=true) 
  {
  if(ObjectFind(no)<0) 
   ObjectCreate(no,OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet(no,OBJPROP_TIME1,t1);
   ObjectSet(no,OBJPROP_PRICE1,p1);
   ObjectSet(no,OBJPROP_TIME2,t2);
   ObjectSet(no,OBJPROP_PRICE2,p2);
   ObjectSet(no,OBJPROP_STYLE,st);
   ObjectSet(no,OBJPROP_COLOR,cl);
   ObjectSet(no,OBJPROP_BACK,Back);
  }
